// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `service.ice'

#include <core/service.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __Tartarus__iface__core__Service__getName_name = "getName";

static const ::std::string __Tartarus__iface__core__Service__isConfigured_name = "isConfigured";

static const ::std::string __Tartarus__iface__core__Service__configure_name = "configure";

::Ice::Object* IceInternal::upCast(::Tartarus::iface::core::Service* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Tartarus::iface::core::Service* p) { return p; }

void
Tartarus::iface::core::__read(::IceInternal::BasicStream* __is, ::Tartarus::iface::core::ServicePrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Tartarus::iface::core::Service;
        v->__copyFrom(proxy);
    }
}

void
Tartarus::iface::core::__writeOptionsDict(::IceInternal::BasicStream* __os, const ::Tartarus::iface::core::OptionsDict& v)
{
    __os->writeSize(::Ice::Int(v.size()));
    ::Tartarus::iface::core::OptionsDict::const_iterator p;
    for(p = v.begin(); p != v.end(); ++p)
    {
        __os->write(p->first);
        __os->write(p->second);
    }
}

void
Tartarus::iface::core::__readOptionsDict(::IceInternal::BasicStream* __is, ::Tartarus::iface::core::OptionsDict& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    while(sz--)
    {
        ::std::pair<const  ::std::string, ::std::string> pair;
        __is->read(const_cast< ::std::string&>(pair.first));
        ::Tartarus::iface::core::OptionsDict::iterator __i = v.insert(v.end(), pair);
        __is->read(__i->second);
    }
}

void
Tartarus::iface::core::__writeServiceSeq(::IceInternal::BasicStream* __os, const ::Tartarus::iface::core::ServicePrx* begin, const ::Tartarus::iface::core::ServicePrx* end)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(begin[i].get())));
    }
}

void
Tartarus::iface::core::__readServiceSeq(::IceInternal::BasicStream* __is, ::Tartarus::iface::core::ServiceSeq& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 2);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        ::Tartarus::iface::core::__read(__is, v[i]);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

::std::string
IceProxy::Tartarus::iface::core::Service::getName(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Tartarus__iface__core__Service__getName_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Tartarus::iface::core::Service* __del = dynamic_cast< ::IceDelegate::Tartarus::iface::core::Service*>(__delBase.get());
            return __del->getName(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::Tartarus::iface::core::Service::isConfigured(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Tartarus__iface__core__Service__isConfigured_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Tartarus::iface::core::Service* __del = dynamic_cast< ::IceDelegate::Tartarus::iface::core::Service*>(__delBase.get());
            return __del->isConfigured(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::Tartarus::iface::core::Service::configure(const ::Tartarus::iface::core::OptionsDict& opts, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Tartarus__iface__core__Service__configure_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Tartarus::iface::core::Service* __del = dynamic_cast< ::IceDelegate::Tartarus::iface::core::Service*>(__delBase.get());
            __del->configure(opts, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::Tartarus::iface::core::Service::ice_staticId()
{
    return ::Tartarus::iface::core::Service::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Tartarus::iface::core::Service::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Tartarus::iface::core::Service);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Tartarus::iface::core::Service::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Tartarus::iface::core::Service);
}

::IceProxy::Ice::Object*
IceProxy::Tartarus::iface::core::Service::__newInstance() const
{
    return new Service;
}

::std::string
IceDelegateM::Tartarus::iface::core::Service::getName(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Tartarus__iface__core__Service__getName_name, ::Ice::Idempotent, __context);
    bool __ok = __og.invoke();
    ::std::string __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

bool
IceDelegateM::Tartarus::iface::core::Service::isConfigured(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Tartarus__iface__core__Service__isConfigured_name, ::Ice::Idempotent, __context);
    bool __ok = __og.invoke();
    bool __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::Tartarus::iface::core::Service::configure(const ::Tartarus::iface::core::OptionsDict& opts, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Tartarus__iface__core__Service__configure_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        ::Tartarus::iface::core::__writeOptionsDict(__os, opts);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Tartarus::iface::core::Error&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        __og.is()->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::std::string
IceDelegateD::Tartarus::iface::core::Service::getName(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::std::string& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Tartarus::iface::core::Service* servant = dynamic_cast< ::Tartarus::iface::core::Service*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->getName(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::std::string& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Tartarus__iface__core__Service__getName_name, ::Ice::Idempotent, __context);
    ::std::string __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

bool
IceDelegateD::Tartarus::iface::core::Service::isConfigured(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(bool& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Tartarus::iface::core::Service* servant = dynamic_cast< ::Tartarus::iface::core::Service*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->isConfigured(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        bool& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Tartarus__iface__core__Service__isConfigured_name, ::Ice::Idempotent, __context);
    bool __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

void
IceDelegateD::Tartarus::iface::core::Service::configure(const ::Tartarus::iface::core::OptionsDict& opts, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Tartarus::iface::core::OptionsDict& opts, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_opts(opts)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Tartarus::iface::core::Service* servant = dynamic_cast< ::Tartarus::iface::core::Service*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                servant->configure(_m_opts, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        const ::Tartarus::iface::core::OptionsDict& _m_opts;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Tartarus__iface__core__Service__configure_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(opts, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Tartarus::iface::core::Error&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

::Ice::ObjectPtr
Tartarus::iface::core::Service::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Tartarus__iface__core__Service_ids[2] =
{
    "::Ice::Object",
    "::Tartarus::iface::core::Service"
};

bool
Tartarus::iface::core::Service::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Tartarus__iface__core__Service_ids, __Tartarus__iface__core__Service_ids + 2, _s);
}

::std::vector< ::std::string>
Tartarus::iface::core::Service::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Tartarus__iface__core__Service_ids[0], &__Tartarus__iface__core__Service_ids[2]);
}

const ::std::string&
Tartarus::iface::core::Service::ice_id(const ::Ice::Current&) const
{
    return __Tartarus__iface__core__Service_ids[1];
}

const ::std::string&
Tartarus::iface::core::Service::ice_staticId()
{
    return __Tartarus__iface__core__Service_ids[1];
}

::Ice::DispatchStatus
Tartarus::iface::core::Service::___getName(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string __ret = getName(__current);
    __os->write(__ret);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Tartarus::iface::core::Service::___isConfigured(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    bool __ret = isConfigured(__current);
    __os->write(__ret);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Tartarus::iface::core::Service::___configure(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Tartarus::iface::core::OptionsDict opts;
    ::Tartarus::iface::core::__readOptionsDict(__is, opts);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        configure(opts, __current);
    }
    catch(const ::Tartarus::iface::core::Error& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

static ::std::string __Tartarus__iface__core__Service_all[] =
{
    "configure",
    "getName",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "isConfigured"
};

::Ice::DispatchStatus
Tartarus::iface::core::Service::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Tartarus__iface__core__Service_all, __Tartarus__iface__core__Service_all + 7, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __Tartarus__iface__core__Service_all)
    {
        case 0:
        {
            return ___configure(in, current);
        }
        case 1:
        {
            return ___getName(in, current);
        }
        case 2:
        {
            return ___ice_id(in, current);
        }
        case 3:
        {
            return ___ice_ids(in, current);
        }
        case 4:
        {
            return ___ice_isA(in, current);
        }
        case 5:
        {
            return ___ice_ping(in, current);
        }
        case 6:
        {
            return ___isConfigured(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
Tartarus::iface::core::Service::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Tartarus::iface::core::Service::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Tartarus::iface::core::Service::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Tartarus::iface::core::Service was not generated with stream support";
    throw ex;
}

void
Tartarus::iface::core::Service::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Tartarus::iface::core::Service was not generated with stream support";
    throw ex;
}

void 
Tartarus::iface::core::__patch__ServicePtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Tartarus::iface::core::ServicePtr* p = static_cast< ::Tartarus::iface::core::ServicePtr*>(__addr);
    assert(p);
    *p = ::Tartarus::iface::core::ServicePtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Tartarus::iface::core::Service::ice_staticId(), v->ice_id());
    }
}

bool
Tartarus::iface::core::operator==(const ::Tartarus::iface::core::Service& l, const ::Tartarus::iface::core::Service& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Tartarus::iface::core::operator<(const ::Tartarus::iface::core::Service& l, const ::Tartarus::iface::core::Service& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}
